/*******************************************************************************
 * Dermi: A DHT-based Peer-to-Peer Middleware for Distributed Components.
 * Copyright (C) 2003-2005 Carles Pairot
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ******************************************************************************/
package org.planet.p2pcm.samples.listener;

import dermi.listener.*;
import java.io.Serializable;

/**
 * This class models the User listener
 *
 * @author Carles Pairot   <carles.pairot@urv.net>
 * @version 1.2
 */
public class UserListener implements BasicListener {
  private String user = null;

  public UserListener (String userName) {
    user = userName;
  }

  public void onEvent (Serializable eL) {
    UserEvent ue = (UserEvent) eL;
    if (ue.hasJoined())
      System.out.println ("I am user " + user + ", and I am told that user " + ue.getUser() + " has joined my place.");
    else
      System.out.println ("I am user " + user + ", and I am told that user " + ue.getUser() + " has left my place.");
  }
}
